using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace ClubDev.LogBot
{
    class Data
    {
        private static string m_ConnectionString = ClubDev_LogBot.Properties.Settings.Default.ClubDevConnectionString;
        private SqlConnection m_sqlConn = null;

        public Data()
        {
            m_sqlConn = new SqlConnection(m_ConnectionString);
        }

        #region Get Table Methods
        public DataTable GetUserTable()
        {
            DataTable dt = new DataTable();

            try
            {
                SqlCommand cmd = new SqlCommand("SELECT userID, userSessionID, userName, userIM, userHost, userIsSharedDisplay, userResolutionX, userResolutionY FROM dbo.Users", m_sqlConn);
                cmd.CommandType = CommandType.Text;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }
            
            return dt;
        }

        public DataTable GetSharedArtifactTable()
        {
            DataTable dt = new DataTable();

            try
            {
                SqlCommand cmd = new SqlCommand("SELECT artifactID, artifactHWND, artifactFullShare, artifactType, artifactName, artifactGroup, artifactOwner FROM dbo.SharedArtifacts", m_sqlConn);
                cmd.CommandType = CommandType.Text;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return dt;
        }

        public DataTable GetSessionsTable()
        {
            DataTable dt = new DataTable();

            try
            {
                SqlCommand cmd = new SqlCommand("SELECT sessionID, sessionName, sessionLocation, sessionPassword FROM dbo.Sessions", m_sqlConn);
                cmd.CommandType = CommandType.Text;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return dt;
        }

        public DataTable GetReplicationsTable()
        {
            DataTable dt = new DataTable();

            try
            {
                SqlCommand cmd = new SqlCommand("SELECT replicationID, replicationSourceHost, replicationSourceHWND, replicationClientHost, replicationIsSharedScreen, replicationClientHWND, replicationLocationX, replicationLocationY FROM dbo.Replications", m_sqlConn);
                cmd.CommandType = CommandType.Text;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return dt;
        }

        public DataTable GetCollaborationRequestsTable()
        {
            DataTable dt = new DataTable();

            try
            {
                SqlCommand cmd = new SqlCommand("SELECT CollaborationRequestID, requestTimeStamp, sessionID, userID, artifactID, comment FROM dbo.CollaborationRequests", m_sqlConn);
                cmd.CommandType = CommandType.Text;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return dt;
        }
        #endregion

        #region Insert Methods
        public void InsertIntoShadowUserTable(DateTime created, long userID, long userSessionID, string userName, string userIM, string userHost, bool userIsSharedDisplay, int userResolutionX, int UserResolutionY)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("INSERT INTO [Shadow-Users] ([created], [userID], [userSessionID], [userName], [userIM], [userHost], [userIsSharedDisplay], [userResolutionX], [userResolutionY]) VALUES(@created, @userID, @userSessionID, @userName, @userIM, @userHost, @userIsSharedDisplay, @userResolutionX, @userResolutionY)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@created", created);
                cmd.Parameters.AddWithValue("@userID", userID);
                cmd.Parameters.AddWithValue("@userSessionID", userSessionID);
                cmd.Parameters.AddWithValue("@userName", userName);
                cmd.Parameters.AddWithValue("@userIM", userIM);
                cmd.Parameters.AddWithValue("@userHost", userHost);
                cmd.Parameters.AddWithValue("@userIsSharedDisplay", userIsSharedDisplay);
                cmd.Parameters.AddWithValue("@userResolutionX", userResolutionX);
                cmd.Parameters.AddWithValue("@userResolutionY", UserResolutionY);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void InsertIntoShaddowSharedArtifactsTable(DateTime created, long artifactID, int artifactHWND, bool artifactFullShare, int artifactType, string artifactName, string artifactGroup, string artifactOwner)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("INSERT INTO [Shadow-SharedArtifacts] ([created], [artifactID], [artifactHWND], [artifactFullShare], [artifactType], [artifactName], [artifactGroup], [artifactOwner]) VALUES(@created, @artifactID, @artifactHWND, @artifactFullShare, @artifactType, @artifactName, @artifactGroup, @artifactOwner)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@created", created);
                cmd.Parameters.AddWithValue("@artifactID", artifactID);
                cmd.Parameters.AddWithValue("@artifactHWND", artifactHWND);
                cmd.Parameters.AddWithValue("@artifactFullShare", artifactFullShare);
                cmd.Parameters.AddWithValue("@artifactType", artifactType);
                cmd.Parameters.AddWithValue("@artifactName", artifactName);
                cmd.Parameters.AddWithValue("@artifactGroup", artifactGroup);
                cmd.Parameters.AddWithValue("@artifactOwner", artifactOwner);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void InsertIntoShadowSessionsTable(DateTime created, long sessionID, string sessionName, string sessionLocation, string sessionPassword)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("INSERT INTO [Shadow-Sessions] ([created], [sessionID], [sessionName], [sessionLocation], [sessionPassword]) VALUES(@created, @sessionID, @sessionName, @sessionLocation, @sessionPassword)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@created", created);
                cmd.Parameters.AddWithValue("@sessionID", sessionID);
                cmd.Parameters.AddWithValue("@sessionName", sessionName);
                cmd.Parameters.AddWithValue("@sessionLocation", sessionLocation);
                cmd.Parameters.AddWithValue("@sessionPassword", sessionPassword);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void InsertIntoShadowReplicationsTable(DateTime created, long replicationID, string replicationSourceHost, int replicationSourceHWND, string replicationClientHost, bool replicationIsSharedScreen, int replicationClientHWND, int replicationLocationX, int replicationLocationY)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("INSERT INTO [Shadow-Replications] ([created], [replicationID], [replicationSourceHost], [replicationSourceHWND], [replicationClientHost], [replicationIsSharedScreen], [replicationClientHWND], [replicationLocationX], [replicationLocationY]) VALUES(@created, @replicationID, @replicationSourceHost, @replicationSourceHWND, @replicationClientHost, @replicationIsSharedScreen, @replicationClientHWND, @replicationLocationX, @replicationLocationY)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@created", created);
                cmd.Parameters.AddWithValue("@replicationID", replicationID);
                cmd.Parameters.AddWithValue("@replicationSourceHost", replicationSourceHost);
                cmd.Parameters.AddWithValue("@replicationSourceHWND", replicationSourceHWND);
                cmd.Parameters.AddWithValue("@replicationClientHost", replicationClientHost);
                cmd.Parameters.AddWithValue("@replicationIsSharedScreen", replicationIsSharedScreen);
                cmd.Parameters.AddWithValue("@replicationClientHWND", replicationClientHWND);
                cmd.Parameters.AddWithValue("@replicationLocationX", replicationLocationX);
                cmd.Parameters.AddWithValue("@replicationLocationY", replicationLocationY);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void InsertIntoShadowCollaborationRequestsTable(DateTime created, long CollaborationRequestID, DateTime requestTimeStamp, long sessionID, long userID, long artifactID, string comment)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("INSERT INTO [Shadow-CollaborationRequests] ([created], [CollaborationRequestID], [requestTimeStamp], [sessionID], [userID], [artifactID], [comment]) VALUES(@created, @CollaborationRequestID, @requestTimeStamp, @sessionID, @userID, @artifactID, @comment)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@created", created);
                cmd.Parameters.AddWithValue("@CollaborationRequestID", CollaborationRequestID);
                cmd.Parameters.AddWithValue("@requestTimeStamp", requestTimeStamp);
                cmd.Parameters.AddWithValue("@sessionID", sessionID);
                cmd.Parameters.AddWithValue("@userID", userID);
                cmd.Parameters.AddWithValue("@artifactID", artifactID);
                cmd.Parameters.AddWithValue("@comment", comment);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }
        #endregion

        #region Update Methods

        public void UpdateShadowUserTable(DateTime removed, long userID, long userSessionID)
        {
            try
            { 
                SqlCommand cmd = new SqlCommand("UPDATE [Shadow-Users] SET [removed] = @removed WHERE (([userID] = @userID) AND ([userSessionID] = @userSessionID))", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@removed", removed);
                cmd.Parameters.AddWithValue("@userID", userID);
                cmd.Parameters.AddWithValue("@userSessionID", userSessionID);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void UpdateShadowSharedArtifactsTable(DateTime removed, long artifactID)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("UPDATE [Shadow-SharedArtifacts] SET [removed] = @removed WHERE ([artifactID] = @artifactID)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@removed", removed);
                cmd.Parameters.AddWithValue("@artifactID", artifactID);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void UpdateShadowSessionsTable(DateTime removed, long sessionID)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("UPDATE [Shadow-Replications] SET [removed] = @removed WHERE ([sessionID] = @sessionID)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@removed", removed);
                cmd.Parameters.AddWithValue("@sessionID", sessionID);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void UpdateShadowReplicationsTable(DateTime removed, long replicationID)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("UPDATE [Shadow-Replications] SET [removed] = @removed WHERE ([replicationID] = @replicationID)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@removed", removed);
                cmd.Parameters.AddWithValue("@replicationID", replicationID);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void UpdateShadowCollaborationRequestsTable(DateTime removed, long CollaborationRequestID)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("UPDATE [Shadow-CollaborationRequests] SET [removed] = @removed WHERE ([CollaborationRequestID] = @CollaborationRequestID)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@removed", removed);
                cmd.Parameters.AddWithValue("@CollaborationRequestID", CollaborationRequestID);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                cmd.ExecuteNonQuery();
            }

            catch (Exception ex)
            {
                throw ex;
            }
        }

        #endregion
    }
}
