using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

using ClubDev.Database;
using ClubDev.Database.ClubDevDataSetTableAdapters;


namespace ClubDev
{
    public partial class CollaboratorBubbleCreate : Form
    {

        private static ClubDevDataSet clubDevDataSet;
        private static SharedArtifactsTableAdapter sharedArtifactsTableAdapter;
        private static CollaborationRequestsTableAdapter collaborationRequestsTableAdapter;

        public Hashtable applicationsTable; 


        public CollaboratorBubbleCreate()
        {
            InitializeComponent();
        }

        private void CollaboratorBubbleCreate_Load(object sender, EventArgs e)
        {

            clubDevDataSet = new ClubDevDataSet();
            sharedArtifactsTableAdapter = new SharedArtifactsTableAdapter();
            collaborationRequestsTableAdapter = new CollaborationRequestsTableAdapter();

            sharedArtifactsTableAdapter.ClearBeforeFill = true;
            sharedArtifactsTableAdapter.FillMETAByGroup(clubDevDataSet.SharedArtifacts, Program.CurrentUser.UserHost);

            applicationsTable = new Hashtable();

            for (int i = 0; i < clubDevDataSet.SharedArtifacts.Rows.Count; i++)
            {
                applicationsTable.Add(clubDevDataSet.SharedArtifacts.Rows[i]["artifactName"], clubDevDataSet.SharedArtifacts.Rows[i]["artifactID"]);
                listOfApplicationsComboBox.Items.Add(clubDevDataSet.SharedArtifacts.Rows[i]["artifactName"]);
            }
        }

        private void listOfApplicationsComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void sendButton_Click(object sender, EventArgs e)
        {
            long artifactID = -1;
            if (applicationsTable != null)
            {
                try
                {
                    artifactID = (long)applicationsTable[listOfApplicationsComboBox.SelectedItem.ToString()];
                }
                catch
                {
                    artifactID = -1;
                }
            }

            string comment = null;
            for (int i = 0; i < commentTextBox.Lines.Length; i++)
            {
                if (i != 0)
                    comment = comment + " ";
                comment = comment + commentTextBox.Lines[i].ToString();
            }

            collaborationRequestsTableAdapter.Insert(Program.CurrentUser.UserSessionID, Program.CurrentUser.UserID, artifactID, comment, DateTime.Now);

            this.Close();
        }


    }
}