using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace ClubDev
{

    public class CollaboratorBubbleData
    {
        private static string m_ConnectionString = ClubDev.Properties.Settings.Default.ClubDevConnectionString;
        private SqlConnection m_sqlConn = null;

        //public delegate void NewMessage();
       // public event NewMessage OnMessage;


        /// <summary>
        /// Constructor
        /// </summary>
        public CollaboratorBubbleData()
        {
            // Stop an existing services on this connection string
            // just be sure
            //SqlDependency.Stop(m_ConnectionString);

            // Start the dependency
            // User must have SUBSCRIBE QUERY NOTIFICATIONS permission
            // Database must also have SSB enabled
            // ALTER DATABASE Chatter SET ENABLE_BROKER
           //SqlDependency.Start(m_ConnectionString);

            // Create the connection
            m_sqlConn = new SqlConnection(m_ConnectionString);

        }

        /// <summary>
        /// Destructor
        /// </summary>
        ~CollaboratorBubbleData()
        {
            // Stop the dependency before exiting
            SqlDependency.Stop(m_ConnectionString);
        }

        public DataTable GetCollaborationRequests(long sessionID)
        {
            DataTable dt = new DataTable();

            try
            {
                // Create command
                // Command must use two part names for tables
                // SELECT <field> FROM dbo.Table rather than 
                // SELECT <field> FROM Table
                // Query also can not use *, fields must be designated
                SqlCommand cmd = new SqlCommand("SELECT requestTimeStamp, sessionID, userID, artifactID, comment FROM dbo.CollaborationRequests WHERE sessionID = @sessionID", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@sessionID", sessionID);

                // Clear any existing notifications
                cmd.Notification = null;

                // Create the dependency for this command
                //SqlDependency dependency = new SqlDependency(cmd);

                // Add the event handler
                //dependency.OnChange += new OnChangeEventHandler(OnRequestChange);

                // Open the connection if necessary
                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                // Get the messages
                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return dt;
        }

        /*
        void OnRequestChange(object sender, SqlNotificationEventArgs e)
        {
            SqlDependency dependency = sender as SqlDependency;

            // Notices are only a one shot deal
            // so remove the existing one so a new 
            // one can be added
            dependency.OnChange -= OnRequestChange;

            // Fire the event
            if (OnMessage != null)
            {
                OnMessage();
            }
        }
        */
    }
}
