using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Media.Animation;

namespace ClubDev
{
    /// <summary>
    /// Interaction logic for waitStar.xaml
    /// </summary>

    public partial class WaitStar : System.Windows.Controls.UserControl
    {
        Storyboard waitAnimation;

        int tick = 150;

        public WaitStar()
        {
            InitializeComponent();

            this.Width = 67;
            this.Height = 67;
            
            waitAnimation = new Storyboard();

            //waitAnimation.RepeatBehavior = RepeatBehavior.Forever;

            ColorAnimationUsingKeyFrames prong0fadeOut = CreateFadeOutAnimation((Shape)Prong0, Prong0.Name, tick * 0);
            waitAnimation.Children.Add(prong0fadeOut);

            ColorAnimationUsingKeyFrames prong1fadeOut = CreateFadeOutAnimation((Shape)Prong1, Prong1.Name, tick * 1);
            waitAnimation.Children.Add(prong1fadeOut);

            ColorAnimationUsingKeyFrames prong2fadeOut = CreateFadeOutAnimation((Shape)Prong2, Prong2.Name, tick * 2);
            waitAnimation.Children.Add(prong2fadeOut);

            ColorAnimationUsingKeyFrames prong3fadeOut = CreateFadeOutAnimation((Shape)Prong3, Prong3.Name, tick * 3);
            waitAnimation.Children.Add(prong3fadeOut);

            ColorAnimationUsingKeyFrames prong4fadeOut = CreateFadeOutAnimation((Shape)Prong4, Prong4.Name, tick * 4);
            waitAnimation.Children.Add(prong4fadeOut);

            ColorAnimationUsingKeyFrames prong5fadeOut = CreateFadeOutAnimation((Shape)Prong5, Prong5.Name, tick * 5);
            waitAnimation.Children.Add(prong5fadeOut);

            ColorAnimationUsingKeyFrames prong6fadeOut = CreateFadeOutAnimation((Shape)Prong6, Prong6.Name, tick * 6);
            waitAnimation.Children.Add(prong6fadeOut);

            ColorAnimationUsingKeyFrames prong7fadeOut = CreateFadeOutAnimation((Shape)Prong7, Prong7.Name, tick * 7);
            waitAnimation.Children.Add(prong7fadeOut);

        }


        private ColorAnimationUsingKeyFrames CreateFadeOutAnimation(Shape target, string targetName, int startTime)
        {
            Color baseColor = Color.FromRgb(100, 100, 100);

            SolidColorBrush animateBrush = new SolidColorBrush();
            animateBrush.Color = baseColor;
            this.RegisterName("animatedBrush" + targetName, animateBrush);

            target.Stroke = animateBrush;

            ColorAnimationUsingKeyFrames colorAnimation = new ColorAnimationUsingKeyFrames();
            colorAnimation.KeyFrames.Add(new LinearColorKeyFrame(baseColor, KeyTime.FromTimeSpan(TimeSpan.FromMilliseconds(0))));
            colorAnimation.KeyFrames.Add(new LinearColorKeyFrame(Colors.LightGray, KeyTime.FromTimeSpan(TimeSpan.FromMilliseconds(tick))));
            colorAnimation.KeyFrames.Add(new LinearColorKeyFrame(baseColor, KeyTime.FromTimeSpan(TimeSpan.FromMilliseconds(tick * 4))));
            colorAnimation.KeyFrames.Add(new LinearColorKeyFrame(baseColor, KeyTime.FromTimeSpan(TimeSpan.FromMilliseconds(tick * 8))));
            colorAnimation.BeginTime = TimeSpan.FromMilliseconds(startTime);
            colorAnimation.AutoReverse = false;
            colorAnimation.RepeatBehavior = RepeatBehavior.Forever;

            Storyboard.SetTargetName(colorAnimation, "animatedBrush" + targetName);

            Storyboard.SetTargetProperty(colorAnimation, new PropertyPath(SolidColorBrush.ColorProperty));

            return colorAnimation;
        }


        public void BeginAnimation()
        {
            waitAnimation.Begin(this, true);
        }

        public void StopAnimation()
        {
            waitAnimation.Stop(this);
        }

    }
}