using System;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;

namespace ClubDev
{
    class SharedArtifactSurogate
    {
        private const int FILE = 0;
        private const int APPLICATION = 1;

        private BitmapSource screenShotSource;
        private BitmapSource iconSource;
        private String artifactName;
        private int id;
        private int type;
        private Size size;
        private Point location;
        private int zOrder;
        private string group;
        private int hwnd;

        #region Properties
        public BitmapSource ScreenShotSource
        {
            get
            {
                return screenShotSource;
            }
            set
            {
                screenShotSource = value;
            }
        }

        public BitmapSource IconSource
        {
            get
            {
                return iconSource;
            }
            set
            {
                iconSource = value;
            }
        }

        public int ID
        {
            get
            {
                return id;
            }
        }

        public int Type
        {
            get
            {
                return type;
            }
        }

        public string ArtifactName
        {
            get
            {
                return artifactName;
            }
        }

        public Size Size
        {
            get
            {
                return size;
            }
        }

        public Point Location
        {
            get
            {
                return location;
            }
        }

        public int ZOrder
        {
            get
            {
                return zOrder;
            }
        }

        public string Group
        {
            get
            {
                return group;
            }
        }

        public int HWND
        {
            get
            {
                return hwnd;
            }
        }

#endregion

        public SharedArtifactSurogate()
        {
            screenShotSource = null;
            iconSource = null;
            artifactName = null;
            group = null;
        }


        ~SharedArtifactSurogate()
        {
            screenShotSource = null;
            iconSource = null;
            artifactName = null;
            group = null;
        }

        public void UpdateArtifact(int id, int type, String artifactName, String group, int hwnd, BitmapSource screenShotSource, BitmapSource iconSource, Size size, Point location, int zOrder)
        {
            this.id = id;
            this.type = type;
            this.artifactName = artifactName;
            this.hwnd = hwnd;
            this.group = group;
            this.screenShotSource = screenShotSource;
            this.iconSource = iconSource;

            this.size = new Size(size.Width, size.Height);
            this.location = new Point(location.X, location.Y);
            this.zOrder = zOrder;
        }

    }
}
