using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ClubDev
{
    public static class SysTrayIcon
    {
        public delegate void CallBack(TrayMessages message);
        public enum TrayMessages
        {
            Exit,
            LeaveSession
        };
        
        static NotifyIcon sysTrayIcon;
        static CallBack cb;

        public static void startSysTrayIcon(object callback)
        {
            sysTrayIconSetup();
            cb = (CallBack)callback;

            sysTrayIcon.Visible = true;

            Application.Run();

        }


        public static void ShowBalloonTip(int timeout, string tipTitle, string tipText, ToolTipIcon tipIcon)
        {
            
            if(sysTrayIcon != null)
                sysTrayIcon.ShowBalloonTip(timeout, tipTitle, tipText, tipIcon);
        }


        static void sysTrayIconSetup()
        {
            ToolStripMenuItem exitItem = new ToolStripMenuItem();
            exitItem.BackColor = System.Drawing.Color.White;
            exitItem.Text = "Exit";
            exitItem.Click += new EventHandler(exitItem_Click);

            ToolStripMenuItem leaveSessionItem = new ToolStripMenuItem();
            leaveSessionItem.BackColor = System.Drawing.Color.White;
            leaveSessionItem.Text = "Leave Session";
            leaveSessionItem.Click += new EventHandler(leaveSessionItem_Click);

            sysTrayIcon = new NotifyIcon();
            sysTrayIcon.Icon = new System.Drawing.Icon(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream("ClubDev.Icons.systray.ico"));
            sysTrayIcon.Text = "ClubDev";
            sysTrayIcon.Visible = true;
            sysTrayIcon.ContextMenuStrip = new ContextMenuStrip();
            sysTrayIcon.ContextMenuStrip.Items.AddRange(
                new System.Windows.Forms.ToolStripItem[]
                {
                    leaveSessionItem,
                    exitItem
                });
        }

        static void leaveSessionItem_Click(object sender, EventArgs e)
        {
            sysTrayIcon.Visible = false;
            sysTrayIcon.Dispose();
            cb(TrayMessages.LeaveSession);
        }

        static void exitItem_Click(object sender, EventArgs e)
        {
            sysTrayIcon.Visible = false;
            sysTrayIcon.Dispose();
            cb(TrayMessages.Exit);
        }

    }
}