using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

using System.Diagnostics;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.ComponentModel;


namespace ClubDev.Utilities
{
    public class IconUtilities
    {

        public static Bitmap GetWindowLargeIconAsBitmap(int handle)
        {
            try
            {
                int result;
                IntPtr hWnd = new IntPtr(handle);
                Win32Api.SendMessageTimeout(hWnd, Win32Api.WM_GETICON, Win32Api.ICON_BIG, 0, Win32Api.SMTO_ABORTIFHUNG, 1000, out result);

                IntPtr hIcon = new IntPtr(result);

                if (hIcon == IntPtr.Zero)
                {
                    result = Win32Api.GetClassLong(hWnd, Win32Api.GCL_HICON);
                    hIcon = new IntPtr(result);
                }

                if (hIcon == IntPtr.Zero)
                {
                    Win32Api.SendMessageTimeout(hWnd, Win32Api.WM_QUERYDRAGICON, 0, 0, Win32Api.SMTO_ABORTIFHUNG, 1000, out result);
                    hIcon = new IntPtr(result);
                }

                if (hIcon == IntPtr.Zero)
                    return null;
                else
                    return Bitmap.FromHicon(hIcon);
            }
            catch (System.Exception)
            {
                //				System.Diagnostics.Trace.WriteLine(systemException);
            }
            return null;
        }
    }
}