using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace CuRTServer.Logging
{
    class Data
    {
        private static string m_ConnectionString = Properties.Settings.Default.ClubDevConnectionString;
        private SqlConnection m_sqlConn = null;
        private long redirectionID;

        public Data()
        {
            m_sqlConn = new SqlConnection(m_ConnectionString);
        }

        public void InsertIntoShadowEventRedirectionsTable(DateTime created, string sharedDisplayHost, string clientHost)
        {
            try
            {
                SqlCommand cmd = new SqlCommand("INSERT INTO [ShadowEvent-Redirections] ([created], [sharedDisplayHost], [clientHost]) VALUES(@created, @sharedDisplayHost, @clientHost);SELECT @@IDENTITY;", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@created", created);
                cmd.Parameters.AddWithValue("@sharedDisplayHost", sharedDisplayHost);
                cmd.Parameters.AddWithValue("@clientHost", clientHost);

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                redirectionID = Convert.ToInt64(cmd.ExecuteScalar());

                m_sqlConn.Close();
            }



            catch (Exception ex)
            {
                throw ex;
            }
        }


        public void UpdateShadowEventRedirectionsTable(DateTime removed)
        {
            if (redirectionID > 0)
            {
                try
                {
                    SqlCommand cmd = new SqlCommand("UPDATE [ShadowEvent-Redirections] SET [removed] = @removed WHERE ([redirectionID] = @redirectionID)", m_sqlConn);
                    cmd.CommandType = CommandType.Text;
                    cmd.Parameters.AddWithValue("@removed", removed);
                    cmd.Parameters.AddWithValue("@redirectionID", this.redirectionID);

                    if (m_sqlConn.State == ConnectionState.Closed)
                        m_sqlConn.Open();

                    cmd.ExecuteNonQuery();

                    m_sqlConn.Close();
                }

                catch (Exception ex)
                {
                    throw ex;
                }
            }
        }
    }
}
