using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Collections;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace PARTIES
{
    
    public partial class Client : Form
    {
        /* Member variables */
        private double ratio;                           //Screen shot ratio ... used during resizing
        
        private System.Windows.Forms.Timer input_timer;
        private bool menu_window;                       //Is this Client a menu?
        private ArrayList keypress_buffer;              //Keystroke buffer
        
        private MouseEventArgs mouse_down_event;

        Bitmap original_icon;

        /* Networking variables */
        private int port;
        private IPAddress serverIP;
        private Socket socket;
        private NetworkStream stream;
        private byte[] buffer;
        private bool header_data;
        private byte header;
        public AsyncCallback dataReceivedCallback;
        IAsyncResult dataReceivedResult;
        private int bytes_received;
        
        ReplicationOptions rep_options;
        bool sql_shutdown;

        ColorBox colorbox;
        Thread my_thread;
        CallBack abortMeCallBack;
        bool closing;

        private long key;
        private bool shared_screen;


        /* CopyPaste vairables */
        string clipboardGUID;

        class KeyPressParameters
        {
            public bool special_character;
            public int key;
            public char charkey;
        }

        public class StartClientParams
        {
            public IPAddress serverIP;
            public int port;
            public Point location;
            public Thread my_thread;
            public CallBack abortMeCallBack;
            public long key;
        }

       

        public static void startClient(object cparams)
        {
            StartClientParams cp = (StartClientParams)cparams;
            Application.Run(new Client(cp.serverIP, cp.port, cp.location, false, cp.my_thread, cp.abortMeCallBack, cp.key));
        }

        public static void startMenuClient(object cparams)
        {
            StartClientParams cp = (StartClientParams)cparams;
            Application.Run(new Client(cp.serverIP, cp.port, cp.location, true, cp.my_thread, cp.abortMeCallBack,0));
        }

        public void abortMe(Thread my_thread)
        {
            my_thread.Abort();
        }

        //Networking test
        public Client(IPAddress serverIP, int port, Point window_location, bool menu_window, Thread thread,
            CallBack abortMeCallBack, long key)
        {
            try
            {

                this.key = key;
                this.closing = false;
                this.abortMeCallBack = abortMeCallBack;
                my_thread = thread;
                this.menu_window = menu_window;
                this.sql_shutdown = false;
                this.port = port;
                this.menu_window = menu_window;


                this.serverIP = serverIP;

                /* Networking stuff */
                socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                // Make the connection
                try
                {
                    socket.Connect(serverIP, port);  // this is a blocking call
                }
                catch (SocketException)
                {
                    // Console.WriteLine(se.Message);
                }


                byte[] header = new byte[1];
                byte[] size = new byte[4];
                stream = new NetworkStream(socket);


                //Wait for a title 

                //Pull off the header
                stream.Read(header, 0, 1);

                //Pull off the size
                stream.Read(size, 0, 4);

                int buffersize = BitConverter.ToInt32(size, 0);
                byte[] title_buf = new byte[buffersize];
                stream.Read(title_buf, 0, buffersize);
                String title_str = Encoding.ASCII.GetString(title_buf);



                //Get screenshot

                //Pull off the header
                stream.Read(header, 0, 1);

                //Pull off the size
                stream.Read(size, 0, 4);

                buffersize = BitConverter.ToInt32(size, 0);
                byte[] screen_shot_buffer = new byte[buffersize];
                int readcount = 0;
                int temp = 0;
                while (readcount < buffersize)
                {
                    temp = stream.Read(screen_shot_buffer, readcount, buffersize - readcount);
                    readcount += temp;
                }


                System.IO.MemoryStream ms = new System.IO.MemoryStream(screen_shot_buffer);
                Bitmap screenshot = new Bitmap(ms);



                //Get icon
                if (!menu_window)
                {
                    //Pull off the header
                    stream.Read(header, 0, 1);

                    //Pull off the size
                    stream.Read(size, 0, 4);

                    buffersize = BitConverter.ToInt32(size, 0);
                    byte[] icon_buffer = new byte[buffersize];
                    readcount = 0;
                    temp = 0;
                    while (readcount < buffersize)
                    {
                        temp = stream.Read(icon_buffer, readcount, buffersize - readcount);
                        readcount += temp;
                    }

                    System.IO.MemoryStream icon_ms = new System.IO.MemoryStream(icon_buffer);
                    original_icon = new Bitmap(icon_ms);

                }

                /* end networking stuff */


                InitializeComponent();

                // Find the ratio of our screenshot
                this.ratio = ((double)screenshot.Height) / screenshot.Width;

                // Set our height and width based on the screenshot size
                if (menu_window)
                {
                    this.Width = screenshot.Width + 8;
                    this.Height = screenshot.Height + 33;
                    this.pictureBox1.Location = new Point(0, 0);

                }
                else //We are grabbing the whole window but offsetting the screenshot so that we don't see the title bar
                {
                    this.Width = screenshot.Width;
                    this.Height = screenshot.Height;
                    this.pictureBox1.Location = new Point(-7, -27);
                }

                //Setup the actual screencapture box
                this.pictureBox1.Width = screenshot.Width;
                this.pictureBox1.Height = screenshot.Height;
                this.pictureBox1.Image = screenshot;

                if (menu_window)
                {
                    this.FormBorderStyle = FormBorderStyle.None;    //Menus don't have borders
                    this.TopMost = true;                            //Menus are on top
                    this.ShowInTaskbar = false;
                }

                // Set the title bar text
                setTitleText("Replicated - " + title_str);


                byte rep_options;
                buffer = new byte[1 + 4 + 1];
                readcount = 0;
                temp = 0;
                while (readcount < 6)
                {
                    temp = stream.Read(buffer, readcount, 6 - readcount);
                    readcount += temp;
                }
                rep_options = buffer[5];

                this.input_timer = new System.Windows.Forms.Timer();
                this.input_timer.Interval = 50;
                this.input_timer.Tick += new EventHandler(input_timer_Tick);
                this.Location = window_location;

                if (rep_options == (byte)ReplicationOptions.INTERACT)
                {
                    this.pictureBox1.MouseDown += new MouseEventHandler(pictureBox1_MouseDown);
                    // this.pictureBox1.DoubleClick += new EventHandler(pictureBox1_DoubleClick);
                    this.KeyPreview = true;
                    this.KeyPress += new KeyPressEventHandler(Client_KeyPress);
                    this.KeyDown += new KeyEventHandler(Client_KeyDown);


                    this.input_timer.Start();
                    this.rep_options = ReplicationOptions.INTERACT;
                    if (!menu_window)
                        this.colorbox = new ColorBox(this.rep_options, new Point(this.Location.X - 3, this.Location.Y - 5), this.Width + 6, this.Height + 10);
                }
                else
                {
                    this.input_timer.Start();
                    this.rep_options = ReplicationOptions.VIEW;
                    if (!menu_window)
                        this.colorbox = new ColorBox(this.rep_options, new Point(this.Location.X - 3, this.Location.Y - 5), this.Width + 6, this.Height + 10);
                }

                if (!menu_window)
                {
                    Bitmap colored_icon = null;
                    if (rep_options == (byte)ReplicationOptions.INTERACT)
                    {
                        colored_icon = (Bitmap)matrixGrayscale(original_icon);
                        colored_icon = CommonThreadCode.matrixColorFilter(colored_icon, Color.Green, 2.0f);
                    }
                    else if (rep_options == (byte)ReplicationOptions.VIEW)
                    {
                        colored_icon = (Bitmap)matrixGrayscale(original_icon);
                        colored_icon = CommonThreadCode.matrixColorFilter(colored_icon, Color.FromArgb(191, 81, 255), 1.25f);
                    }
                    this.Icon = Icon.FromHandle(colored_icon.GetHicon());
                }

                keypress_buffer = new ArrayList();

                header_data = true;
                buffer = new byte[5];
                bytes_received = 0;

                if (!menu_window)
                {
                    DispatchServerData.UpdateReplication(this.key, (int)this.Handle);
                }
                if (DispatchServerData.GetReplicationIsSharedScreen(key) == 1)
                    shared_screen = true;
                else
                    shared_screen = false;



                //send back to the server the information about the local HWND so that it can bootstrap telepointers

                byte[] bufferedData = new byte[1 + 4 + 4];

                bufferedData[0] = (byte)NetworkMessages.MessageType.ClientHWND;

                int clientHWND = this.Handle.ToInt32();

                byte[] sizeInBytes = BitConverter.GetBytes(bufferedData.Length - 5);
                byte[] clientHWNDInBytes = BitConverter.GetBytes(clientHWND);


                //Copy in buffer length
                for (int k = 0; k < 4; k++)
                {
                    bufferedData[k + 1] = sizeInBytes[k];
                    bufferedData[k + 5] = clientHWNDInBytes[k];

                }

                NetworkMessages.safeWrite(stream, bufferedData, 0, bufferedData.Length,
                    new NetworkMessages.exceptionCallback(this.grayClient));






                waitForData();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        
        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);
            Win32Api.SetForegroundWindow((int)this.Handle);
        }

        public Image matrixGrayscale(Bitmap image)
        {
            Image bmp = new Bitmap(image);
            
            Graphics g = Graphics.FromImage(bmp);
            
            System.Drawing.Imaging.ImageAttributes imageAttributes = new System.Drawing.Imaging.ImageAttributes();
            Rectangle rectangle = new Rectangle(0, 0, bmp.Width, bmp.Height);
            

                        
            System.Drawing.Imaging.ColorMatrix cm;

            //CCIR 709 standard grayscale
            float[][] colorMatrixElements = {
            new float[] {0.299f, 0.299f, 0.299f, 0, 0},
            new float[] {0.587f, 0.587f, 0.587f, 0, 0},
            new float[] {0.114f, 0.114f, 0.114f, 0, 0},
            new float[] {0, 0, 0, 1, 0},
            new float[] {0, 0, 0, 0, 1}};

            cm = new System.Drawing.Imaging.ColorMatrix(colorMatrixElements);

            imageAttributes.SetColorMatrix(cm, System.Drawing.Imaging.ColorMatrixFlag.Default, System.Drawing.Imaging.ColorAdjustType.Bitmap);

            
            g.DrawImage(bmp, rectangle, 0, 0, bmp.Width, bmp.Height, GraphicsUnit.Pixel, imageAttributes);
            g.Dispose();
            return bmp;
        }

        

        protected override void OnMove(EventArgs e)
        {
            base.OnMove(e);
            if (!menu_window)
            {
                Point new_location = new Point(this.Location.X-3, this.Location.Y - 5);
                colorbox.Location = new_location;
                
                Win32Api.SetWindowPos((int)colorbox.Handle, (int)this.Handle, 0, 0, 0, 0,
                    Win32Api.SWP_NOSIZE | Win32Api.SWP_NOMOVE|
                    Win32Api.SWP_NOACTIVATE);
            }
        }

        void waitForData()
        {

            if (dataReceivedCallback == null)
                dataReceivedCallback = new AsyncCallback(onDataReceived);
            // now start to listen for any data...
            dataReceivedResult = socket.BeginReceive(buffer, bytes_received, buffer.Length-bytes_received, SocketFlags.None, dataReceivedCallback, null);

        }


        // We finished receieving data
        //We can receive:
        //
        //   - Screenshots
        //   - Window title updates
        //   - New menu messages (not yet implemented)
        //
        //   - This function will be called twice for each of these
        //      The first time will be to pull off a header type and data buffer size
        //      The second time wil be the actual data
        public void onDataReceived(IAsyncResult asyn)
        {


            try
            {
                int just_received = 0;
                just_received = socket.EndReceive(asyn);
                bytes_received += just_received;
                if (bytes_received < buffer.Length)
                {
                    waitForData();
                    return;
                }
                bytes_received = 0;
        
                //do whatever we need to with what we just received
                //we will either be waiting for a header or for data ...
                if (header_data)
                {
                    header = buffer[0];
                    int data_buffer_length = BitConverter.ToInt32(buffer,1);
                    buffer = new byte[data_buffer_length];
                    header_data = false;
                }
                else
                {
                    processDataBuffer();
                    header_data = true;
                    buffer = new byte[5];
                }

                
                //set up on data received
                waitForData();
            }
            catch (ObjectDisposedException)
            {
                // Console.WriteLine("onDataReceieved: Socket has been closed");
            }
            catch (SocketException se)
            {
                MessageBox.Show("E100: " + se.Message);
            }

        }

        private delegate void setTitleTextDelegate(string label);
        private void setTitleText(string label)
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                // Pass the same function to BeginInvoke,
                // but the call would come on the correct
                // thread and InvokeRequired will be false.
                this.BeginInvoke(new setTitleTextDelegate(setTitleText), 
                                                  new object[] {label});

                 return;
             }

             this.Text = label;
              
        }

       
        private delegate void hideAndCloseDelegate();
        private void hideAndClose()
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                // Pass the same function to BeginInvoke,
                // but the call would come on the correct
                // thread and InvokeRequired will be false.
                this.BeginInvoke(new hideAndCloseDelegate(hideAndClose),null);

                return;
            }

            input_timer.Stop();
            this.Close();
        }

        private delegate void closeFormDelegate();
        private void closeForm()
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                // Pass the same function to BeginInvoke,
                // but the call would come on the correct
                // thread and InvokeRequired will be false.
                this.BeginInvoke(new closeFormDelegate(closeForm));

                return;
            }

            this.Close();

        }

        private delegate void changeIconColorDelegate(Color color, float brightness);
        private void changeIconColor(Color color, float brightness)
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                // Pass the same function to BeginInvoke,
                // but the call would come on the correct
                // thread and InvokeRequired will be false.
                this.BeginInvoke(new changeIconColorDelegate(changeIconColor),
                                                  new object[] { color, brightness });

                return;
            }

            Bitmap colored_icon = (Bitmap)matrixGrayscale(original_icon);
            
            if (!(color == Color.Gray))
            {
                colored_icon = CommonThreadCode.matrixColorFilter(colored_icon, color, brightness);
            }

            this.Icon = Icon.FromHandle(colored_icon.GetHicon());

      
        }




        void processDataBuffer()
        {
            if (header == (byte)NetworkMessages.MessageType.ScreenShot)
            {
                System.IO.MemoryStream ms = new System.IO.MemoryStream(buffer);
                Bitmap screenshot = new Bitmap(ms);
                this.pictureBox1.Image = screenshot;
            }
            else if (header == (byte)NetworkMessages.MessageType.TitleBarText)
            {
               String title_str = Encoding.ASCII.GetString(buffer);
               setTitleText("Replicated - " + title_str);
            }
            else if (header == (byte)NetworkMessages.MessageType.ChangePermissions)
            {
                byte new_rep_options = buffer[0];

                if(rep_options == ReplicationOptions.VIEW && 
                    new_rep_options == (byte)ReplicationOptions.INTERACT)
                {
                    this.pictureBox1.MouseDown += new MouseEventHandler(pictureBox1_MouseDown);
                    // this.pictureBox1.DoubleClick += new EventHandler(pictureBox1_DoubleClick);
                    this.KeyPreview = true;
                    this.KeyPress += new KeyPressEventHandler(Client_KeyPress);
                    this.KeyDown += new KeyEventHandler(Client_KeyDown);

                    this.rep_options = ReplicationOptions.INTERACT;
                    this.colorbox.permissionsChanged(this.rep_options);
                    changeIconColor(Color.Green, 2.0f);
                }
                else if (rep_options == ReplicationOptions.INTERACT &&
                    new_rep_options == (byte)ReplicationOptions.VIEW)
                {
                    this.pictureBox1.MouseDown -= new MouseEventHandler(pictureBox1_MouseDown);
                    // this.pictureBox1.DoubleClick += new EventHandler(pictureBox1_DoubleClick);
                    this.KeyPreview = false;
                    this.KeyPress -= new KeyPressEventHandler(Client_KeyPress);
                    this.KeyDown -= new KeyEventHandler(Client_KeyDown);

                    this.rep_options = ReplicationOptions.VIEW;
                    this.colorbox.permissionsChanged(this.rep_options);
                    changeIconColor(Color.Yellow, 1.0f);
                }

            }
            else if (header == (byte)NetworkMessages.MessageType.CloseReplication)
            {
                byte garbage = buffer[0];
                if (menu_window)
                {
                    socket.Shutdown(SocketShutdown.Both);
                    stream.Close();
                    socket.Close();
                    hideAndClose();
                    return;
                }
                this.colorbox.replicationEnded();
                changeIconColor(Color.Gray, 1);
                sql_shutdown = true;
                this.pictureBox1.Image = matrixGrayscale((Bitmap)this.pictureBox1.Image);
                
                if (rep_options == ReplicationOptions.VIEW)
                {
                    socket.Shutdown(SocketShutdown.Both);
                    stream.Close();
                    socket.Close();
                }
                else if (rep_options == ReplicationOptions.INTERACT)
                {
                    this.pictureBox1.MouseDown -= new MouseEventHandler(pictureBox1_MouseDown);
                    // this.pictureBox1.DoubleClick += new EventHandler(pictureBox1_DoubleClick);
                    this.KeyPreview = false;
                    this.KeyPress -= new KeyPressEventHandler(Client_KeyPress);
                    this.KeyDown -= new KeyEventHandler(Client_KeyDown);

                    this.input_timer.Stop();
                    this.rep_options = ReplicationOptions.VIEW;
                    socket.Shutdown(SocketShutdown.Both);
                    stream.Close();
                    socket.Close();
                }

                if (shared_screen)
                    closeForm();

            }
            else if (header == (byte)NetworkMessages.MessageType.NewMenu)
            {
                // get menu information
                // -Port
                // -x offset (just add each offset to our current location.X and Y
                // -y offset
                int port=BitConverter.ToInt32(buffer,0);
                int x_offset = BitConverter.ToInt32(buffer, 4);
                int y_offset = BitConverter.ToInt32(buffer, 8);
                // start a new client thread for the menu

                //set server IP
                StartClientParams cp = new StartClientParams();
                cp.serverIP = ((IPEndPoint)socket.RemoteEndPoint).Address;
                cp.port = port;
                cp.location = new Point();
                cp.location.X = this.Location.X + x_offset;
                cp.location.Y = this.Location.Y + y_offset;
                cp.abortMeCallBack = new CallBack(abortMe);

                ParameterizedThreadStart threadDelegate = new ParameterizedThreadStart(Client.startMenuClient);
                Thread newthread = new Thread(threadDelegate);
                cp.my_thread = newthread;

                newthread.Start(cp);
                //Client menu = new Client(cp.serverIP, cp.port, cp.location, true);
                //menu.Show();
            }

            else if ((header == (byte)NetworkMessages.MessageType.ClipboardCopy) || (header == (byte)NetworkMessages.MessageType.ClipboardCut))
            {
                Console.WriteLine("received remote copy/cut action");

                CopyPaste_SetLocalClipboard(buffer);
            }

        }

        //NETWORK READY
        void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            mouse_down_event = e;
            //Pack the mouse location into an int
            //click_location = (e.Location.Y * 0x10000) | (e.Location.X & 0xFFFF);
            byte[] click_location_X_buf = BitConverter.GetBytes(e.Location.X);
            byte[] click_location_Y_buf = BitConverter.GetBytes(e.Location.Y);
            byte[] bufferedData = new byte[1 + 4 + 1 + 4 + 4];

            //Data format [a -> byte] = Type a was converted to a byte for transfer:
            //
            // data[0] = message type [byte]
            // data[1] = message length [int]
            // data[5] = mouse button [byte]
            // data[6...9] = mouse location.X
            // data[10...13] = mouse location.Y

            bufferedData[0] = (byte)NetworkMessages.MessageType.MouseDown;
            byte[] buffer_size = BitConverter.GetBytes(9);
            for (int i = 0; i < 4; i++)
            {
                bufferedData[i + 1] = buffer_size[i];
            }

            if (e.Button == MouseButtons.Left)
                bufferedData[5] = (byte)NetworkMessages.MouseButton.Left;
            else if (e.Button == MouseButtons.Middle)
                bufferedData[5] = (byte)NetworkMessages.MouseButton.Middle;
            else if (e.Button == MouseButtons.Right)
                bufferedData[5] = (byte)NetworkMessages.MouseButton.Right;
            else //we have a problem
                return;

            //Copy mouse click location
            for (int i = 0; i < 4; i++)
            {
                bufferedData[6 + i] = click_location_X_buf[i];
            }

            for (int i = 0; i < 4; i++)
            {
                bufferedData[10 + i] = click_location_Y_buf[i];
            }

            NetworkMessages.safeWrite(stream, bufferedData, 0, bufferedData.Length, 
                new NetworkMessages.exceptionCallback(this.grayClient));
            //stream.Write(bufferedData,0,bufferedData.Length);
        }


        //NETWORK READY
        void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            //click_location and mouse_down_event have already been set by mouse down

            byte[] click_location_X_buf = BitConverter.GetBytes(mouse_down_event.Location.X);
            byte[] click_location_Y_buf = BitConverter.GetBytes(mouse_down_event.Location.Y);
            byte[] bufferedData = new byte[1 + 4 + 1 + 4 + 4];

            //Data format [a -> byte] = Type a was converted to a byte for transfer:
            //
            // data[0] = message type [byte]
            // data[1] = message length [int]
            // data[5] = mouse button [byte]
            // data[6...9] = mouse location.X
            // data[10...13] = mouse location.Y

            bufferedData[0] = (byte)NetworkMessages.MessageType.MouseDblClick;
            byte[] buffer_size = BitConverter.GetBytes(9);
            for (int i = 0; i < 4; i++)
            {
                bufferedData[i + 1] = buffer_size[i];
            }

            if (mouse_down_event.Button == MouseButtons.Left)
                bufferedData[5] = (byte)NetworkMessages.MouseButton.Left;
            else if (mouse_down_event.Button == MouseButtons.Middle)
                bufferedData[5] = (byte)NetworkMessages.MouseButton.Middle;
            else if (mouse_down_event.Button == MouseButtons.Right)
                bufferedData[5] = (byte)NetworkMessages.MouseButton.Right;
            else //we have a problem
                return;

            //Copy mouse click location
            for (int i = 0; i < 4; i++)
            {
                bufferedData[6 + i] = click_location_X_buf[i];
            }

            for (int i = 0; i < 4; i++)
            {
                bufferedData[10 + i] = click_location_Y_buf[i];
            }

            NetworkMessages.safeWrite(stream, bufferedData, 0, bufferedData.Length,
                new NetworkMessages.exceptionCallback(this.grayClient));
            //stream.Write(bufferedData, 0, bufferedData.Length);
        }

        private void grayClient()
        {
            byte garbage = buffer[0];
            if (menu_window)
            {
                socket.Shutdown(SocketShutdown.Both);
                stream.Close();
                socket.Close();
                hideAndClose();
                return;
            }
            this.colorbox.replicationEnded();
            changeIconColor(Color.Gray, 1);
            sql_shutdown = true;
            this.pictureBox1.Image = matrixGrayscale((Bitmap)this.pictureBox1.Image);


            if (rep_options == ReplicationOptions.VIEW)
            {
                socket.Shutdown(SocketShutdown.Both);
                stream.Close();
                socket.Close();
            }
            else if (rep_options == ReplicationOptions.INTERACT)
            {
                this.pictureBox1.MouseDown -= new MouseEventHandler(pictureBox1_MouseDown);
                // this.pictureBox1.DoubleClick += new EventHandler(pictureBox1_DoubleClick);
                this.KeyPreview = false;
                this.KeyPress -= new KeyPressEventHandler(Client_KeyPress);
                this.KeyDown -= new KeyEventHandler(Client_KeyDown);

                this.input_timer.Stop();
                this.rep_options = ReplicationOptions.VIEW;
                socket.Shutdown(SocketShutdown.Both);
                stream.Close();
                socket.Close();
            }

            if (shared_screen)
                closeForm();
        }

        private void closeClient()
        {
            if (!sql_shutdown && !closing)
            {
                closing = true;
                //Tell the server that we are closing
                //click_location and mouse_down_event have already been set by mouse down

                byte[] bufferedData = new byte[1 + 4];

                //Data format [a -> byte] = Type a was converted to a byte for transfer:
                //
                // data[0] = message [byte]


                bufferedData[0] = (byte)NetworkMessages.MessageType.ClientClosing;
                for (int i = 0; i < 4; i++)
                {
                    bufferedData[i + 1] = 0;
                }
                try
                {
                    stream.Write(bufferedData, 0, bufferedData.Length);
                }
                catch (Exception)
                {

                }
                try
                {
                    stream.Close(10000);
                    socket.Shutdown(SocketShutdown.Both);
                }
                catch (ObjectDisposedException)
                {

                }
                stream.Close();
                socket.Close();
                hideAndClose();
            }
        }

        protected override void OnClosing(CancelEventArgs e)
        {

            base.OnClosing(e);

            closeClient();
        }
        


     
        //NETWORK READY
        void Client_KeyDown(object sender, KeyEventArgs e)
        {
            /* // Console.WriteLine("Key code = " + e.KeyCode.ToString() +
                 " Key Value = " + e.KeyValue.ToString()); */

            if ((e.KeyValue >= 0x08 && e.KeyValue <= 0x1B)
                || (e.KeyValue >= 0x21 && e.KeyValue <= 0x2F)
                || (e.KeyValue >= 0x60 && e.KeyValue <= 0x69))
            {
                KeyPressParameters kpress = new KeyPressParameters();
                kpress.key = e.KeyValue;
                kpress.special_character = true;
                keypress_buffer.Add(kpress);
                e.Handled = true;
            }

        }

        //NETWORK READY
        // Key press is not raised for non-standard (e.g. ALT, CTRL keys)
        void Client_KeyPress(object sender, KeyPressEventArgs e)
        {

            if ((int)e.KeyChar == 22) // this is paste request, handle appropriately
            {
                e.Handled = true;
                Console.WriteLine("PASTE DETECTED");
                CopyPaste_SendLocalClipboard();
                return;
            }

            if ((int)e.KeyChar == 3)
            {
                e.Handled = true;
                Console.WriteLine("COPY DETECTED");
                CopyPaste_SendRemoteRequest(NetworkMessages.MessageType.ClipboardCopy);
                return;
            }

            if ((int)e.KeyChar == 24)
            {
                e.Handled = true;
                Console.WriteLine("CUT DETECTED");
                CopyPaste_SendRemoteRequest(NetworkMessages.MessageType.ClipboardCut);
                return;
            }




            // Just add the keypress to the buffer, we will send the keypresses in a timer
            // \r = enter, \b = backspace \t = tab
            if ((int)e.KeyChar >= 32 && (int)e.KeyChar <= 126)
            {
                KeyPressParameters kpress = new KeyPressParameters();
                kpress.charkey = e.KeyChar;
                kpress.special_character = false;
                keypress_buffer.Add(kpress);
                e.Handled = true;
            }
        }


        private delegate void CopyPaste_SetLocalClipboardDelagate(byte[] buffer);
        void CopyPaste_SetLocalClipboard(byte[] buffer)
        {

            if (this.InvokeRequired)
            {
                this.BeginInvoke(new CopyPaste_SetLocalClipboardDelagate(CopyPaste_SetLocalClipboard), new object[] { buffer });
                return;
            }

            DataObject dataObject = new DataObject();

            int currentPosition = 0;

            while (currentPosition < buffer.Length)
            {
                int sizeOfFormat = BitConverter.ToInt32(buffer, currentPosition);
                int sizeOfObjectType = BitConverter.ToInt32(buffer, currentPosition + 4);
                long sizeOfMemoryStream = BitConverter.ToInt64(buffer, currentPosition + 8);


                char[] formatInBytes = new char[sizeOfFormat];
                char[] objectTypeInBytes = new char[sizeOfObjectType];
                byte[] memoryStreamInBytes = new byte[sizeOfMemoryStream];

                for (int i = 0; i < formatInBytes.Length; i++)
                    formatInBytes[i] = (char)buffer[currentPosition + 16 + i];

                for (int i = 0; i < objectTypeInBytes.Length; i++)
                    objectTypeInBytes[i] = (char)buffer[currentPosition + 16 + formatInBytes.Length + i];

                for (int i = 0; i < memoryStreamInBytes.Length; i++)
                    memoryStreamInBytes[i] = buffer[currentPosition + 16 + formatInBytes.Length + objectTypeInBytes.Length + i];


                string format = new String(formatInBytes);
                string objectType = new String(objectTypeInBytes);

                System.IO.MemoryStream memoryStream = new System.IO.MemoryStream(memoryStreamInBytes);


                CopyPaste_ProcessClipboardDataObject(objectType, format, memoryStream, ref dataObject);


                currentPosition += 1 + 16 + sizeOfFormat + sizeOfObjectType + (int)sizeOfMemoryStream;

            }

            Clipboard.SetDataObject(dataObject, true);

        }


        private DataObject CopyPaste_ProcessClipboardDataObject(string objectType, string format, System.IO.MemoryStream memStream, ref DataObject dataObject)
        {

            //here we handle the different object types before adding them to the clipboard data object.
            if (objectType == "Bitmap" || objectType == "System.Drawing.Bitmap")
            {
                System.Drawing.Bitmap bitmap = new Bitmap(memStream);
                dataObject.SetData(format, bitmap);
            }
            else if (objectType == "MemoryStream" || objectType == "System.IO.MemoryStream")
            {
                dataObject.SetData(format, memStream);
            }
            else if (objectType == "String" || objectType == "System.String")
            {
                byte[] memoryStreamInBytes = new byte[memStream.Length];
                memStream.Read(memoryStreamInBytes, 0, (int)memStream.Length);

                UnicodeEncoding uniEncoding = new UnicodeEncoding();
                string ourText = uniEncoding.GetString(memoryStreamInBytes);
                dataObject.SetData(format, ourText);
            }

            /*
            else if (objectType == "File")
            {


                //parse out the format and filename
                int indexOfFileName = clipBoardStream.Format.IndexOf("FILENAME");
                string format = clipBoardStream.Format.Substring(indexOfFileName + 8);
                string fileName = clipBoardStream.Format.Substring(0, indexOfFileName);

                string filePath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\ClipboardAPP\\" + clipBoardStream.ClipBoardID;

                if (!Directory.Exists(filePath))
                {
                    try
                    {
                        //delete any existing files from previous pastes before creating the new directory
                        Directory.Delete(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\ClipboardAPP", true);
                    }
                    catch
                    {
                        // do nothing.
                    }
                    Directory.CreateDirectory(filePath);
                }

                filePath += "\\" + fileName;

                if (System.IO.File.Exists(filePath))
                {
                    System.IO.File.Delete(filePath);
                }

                //determind the length of the file itself (not including the embedded name) and write it to disk.

                FileStream fileStream = new FileStream(filePath, System.IO.FileMode.CreateNew);
                fileStream.Write(clipBoardStream.Buffer, 0, clipBoardStream.Buffer.Length);
                fileStream.Close();


                string[] fileNames = (string[])dataObject.GetData(format);
                if (fileNames == null)
                {
                    Array.Resize(ref fileNames, 1);
                }
                else
                {
                    Array.Resize(ref fileNames, fileNames.Length + 1);
                }

                fileNames[fileNames.Length - 1] = filePath;

                dataObject.SetData(format, fileNames);

            }
            */
            else
            {
                dataObject.SetData(format, memStream);
            }

            return dataObject;
        }

        void CopyPaste_SendRemoteRequest(NetworkMessages.MessageType messageType)
        {
            byte[] bufferedData = new byte[1500];
            bufferedData[0] = (byte)messageType;

            byte[] totalPayloadSize = BitConverter.GetBytes(1495);

            for (int j = 0; j < 4; j++)
                bufferedData[1 + j] = totalPayloadSize[j];

            NetworkMessages.safeWrite(stream, bufferedData, 0, bufferedData.Length,
                new NetworkMessages.exceptionCallback(this.grayClient));
        }

        private delegate void CopyPaste_SendLocalClipboardDelagate();
        void CopyPaste_SendLocalClipboard()
        {


            if (this.InvokeRequired)  
            {
                this.BeginInvoke(new CopyPaste_SendLocalClipboardDelagate(CopyPaste_SendLocalClipboard), null);
                return;
            }

            IDataObject clipboardData = Clipboard.GetDataObject();

            string[] formats = clipboardData.GetFormats();
            byte[][] formatsInByteArrays = new byte[formats.Length][];
            int i = 0;

            foreach(string format in formats)
            {
                object clipboardDataObject = null;

                if (format.ToLower() != "enhancedmetafile")
                {
                    clipboardDataObject = clipboardData.GetData(format);
                    if (clipboardDataObject != null)
                    {
                        formatsInByteArrays[i] = ClipboardOperations.ConvertObjectToByteArray(clipboardDataObject, format);
                    }
                }
            
                i++;
            }

            int totalSize = 0;
            foreach(byte[] formatInByteArray in formatsInByteArrays)
                if(formatInByteArray != null)
                    totalSize += formatInByteArray.Length;


            byte[] bufferedData = new byte[1 + 4 + totalSize];

            bufferedData[0] = (byte)NetworkMessages.MessageType.ClipboardPaste;

            byte[] totalPayloadSize = BitConverter.GetBytes(totalSize);

            for(int j = 0; j < 4; j++)
                bufferedData[1 + j] = totalPayloadSize[j];

            int currentOffset = 5;

            foreach (byte[] formatInByteArray in formatsInByteArrays)
                if(formatInByteArray != null)
                {
                    for(int j = 0; j < formatInByteArray.Length; j++)
                        bufferedData[currentOffset + j] = formatInByteArray[j];
                    
                    currentOffset += formatInByteArray.Length;
                }

            NetworkMessages.safeWrite(stream, bufferedData, 0, bufferedData.Length,
                new NetworkMessages.exceptionCallback(this.grayClient));

        }

        


        //NETWORK READY
        void input_timer_Tick(object sender, EventArgs e)
        {


            if (!menu_window)
            {
                Point new_location = new Point(this.Location.X - 3, this.Location.Y - 5);
                colorbox.Location = new_location;

                Win32Api.SetWindowPos((int)colorbox.Handle, (int)this.Handle, 0, 0, 0, 0,
                    Win32Api.SWP_NOSIZE | Win32Api.SWP_NOMOVE | 
                    Win32Api.SWP_NOACTIVATE);
            }

            if (keypress_buffer.Count < 1)
                return;

 
            byte[] key_id;
            byte[] bufferedData = new byte[1+4+((1+4+1)*keypress_buffer.Count)];
           
            //Data format [a -> byte] = Type a was converted to a byte for transfer:
            //
            // data[0] = message type [byte]
            // data[1...4] = number of keypress events in data buffer [int]
            // data[5...n] = keypress data
            //
            // keypress data:
            // data[5] = special character [bool -> byte]
            // data[6...9] = int key id [int]
            // data[10] = char key [char -> byte]

            bufferedData[0] = (byte)NetworkMessages.MessageType.KeyBoardBuffer;
            byte[] num_presses = BitConverter.GetBytes((1 + 4 + 1) * keypress_buffer.Count);
            
            //Copy in buffer length
            for (int k = 0; k < 4; k++)
            {
                bufferedData[k + 1] = num_presses[k];
            }
            int i = 5;
            byte special_character;
            foreach(KeyPressParameters press in keypress_buffer)
            {
                key_id = BitConverter.GetBytes(press.key);
                if (press.special_character)
                    special_character = 1;
                else
                    special_character = 0;
                bufferedData[i]=special_character;
                for(int j=1; j<=4; j++)
                {
                    bufferedData[i+j]=key_id[j-1];
                }
                bufferedData[i+5]=(byte)press.charkey;
            }

            NetworkMessages.safeWrite(stream, bufferedData, 0, bufferedData.Length,
                new NetworkMessages.exceptionCallback(this.grayClient));

            keypress_buffer.Clear();
        }

        

        

        

        



        


        



          

    }
}