using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PARTIES
{
    public partial class ColorBox : Form
    {
        Color close_color;
        Color view_color;
        Color interact_color;

        
        public ColorBox(ReplicationOptions rep_options, Point location, int width, int height)
        {
            close_color = Color.Gray;
            interact_color = Color.Green;
            view_color = Color.FromArgb(191, 81, 255);

            InitializeComponent();
            this.ControlBox = false;
            this.Text = "";
            if (rep_options == ReplicationOptions.INTERACT)
                this.BackColor = interact_color;
            else if (rep_options == ReplicationOptions.VIEW)
                this.BackColor = view_color;

            this.Location = location;
            this.Width = width;
            this.Height = height;
            this.Show();
        }

        public void permissionsChanged(ReplicationOptions rep_options)
        {
            if (rep_options == ReplicationOptions.INTERACT)
                this.BackColor = interact_color;
            else if (rep_options == ReplicationOptions.VIEW)
                this.BackColor = view_color;
        }

        public void replicationEnded()
        {
            this.BackColor = close_color;
        }

    }
}