using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace PARTIES
{

    public delegate void DataEventHandler(object sender, DataTable result);

    public class DispatchServerData
    {
        private static string m_ConnectionString = "Server=ClubDev;Database=ClubDev;User ID=ClubDevUser;pwd=orchid";
        private SqlConnection m_sqlConn = null;

        public delegate void NewMessage();
        //public event NewMessage OnNewReplicationMessage;
        //public event NewMessage OnNewPermissionMessage;

        public event DataEventHandler OnNewReplicationEvent;
        public event DataEventHandler OnNewPermissionEvent;

        private System.Windows.Forms.Timer timer;

        private string hostnameToMonitor;

        /// <summary>
        /// Constructor
        /// </summary>
        public DispatchServerData(string hostnameToMonitor)
        {

            /*
            // Stop an existing services on this connection string
            // just be sure
            SqlDependency.Stop(m_ConnectionString);
            
            // Start the dependency
            // User must have SUBSCRIBE QUERY NOTIFICATIONS permission
            // Database must also have SSB enabled
            // ALTER DATABASE Chatter SET ENABLE_BROKER
            SqlDependency.Start(m_ConnectionString);

            // Create the connection
            m_sqlConn = new SqlConnection(m_ConnectionString);
             
            */

            this.hostnameToMonitor = hostnameToMonitor;

            timer = new System.Windows.Forms.Timer();
            timer.Interval = 1000;
            timer.Tick += new EventHandler(timer_Tick);
            timer.Start();

        }



        /// <summary>
        /// Destructor
        /// </summary>
        ~DispatchServerData()
        {
            // Stop the dependency before exiting
            //SqlDependency.Stop(m_ConnectionString);

            timer.Stop();
            timer.Dispose();
        }


        void timer_Tick(object sender, EventArgs e)
        {
            DataTable currentShareState = GetShareState();
            OnNewPermissionEvent(this, currentShareState);

            DataTable currentReplicationState = GetReplicationState();
            OnNewReplicationEvent(this, currentReplicationState);
            
        }


        /// <summary>
        /// Retreive messages from database
        /// </summary>
        /// <returns></returns>
        public DataTable GetReplicationState()
        {
            DataTable dt = new DataTable();

            try
            {
                // Create command
                // Command must use two part names for tables
                // SELECT <field> FROM dbo.Table rather than 
                // SELECT <field> FROM Table
                // Query also can not use *, fields must be designated
                SqlCommand cmd = new SqlCommand("SELECT replicationID, replicationSourceHost, replicationSourceHWND, replicationClientHost, replicationIsSharedScreen FROM dbo.Replications WHERE replicationSourceHost = @replicationSourceHost", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@replicationSourceHost", hostnameToMonitor);

                // Clear any existing notifications
                //cmd.Notification = null;

                // Create the dependency for this command
                //SqlDependency dependency = new SqlDependency(cmd);

                // Add the event handler
                //dependency.OnChange += new OnChangeEventHandler(OnReplicationChange);

                // Open the connection if necessary
                if(m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                // Get the messages
                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show("There has been an error with the SQL server: \\n\\" + ex.Message, "SQL error", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                throw ex;
            }

            return dt;
        }

        /*
        /// <summary>
        /// Handler for the SqlDependency OnChange event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void OnReplicationChange(object sender, SqlNotificationEventArgs e)
        {
            SqlDependency dependency = sender as SqlDependency;
            
            // Notices are only a one shot deal
            // so remove the existing one so a new 
            // one can be added
            dependency.OnChange -= OnReplicationChange;

            // Fire the event
            if (OnNewReplicationMessage != null)
            {
                OnNewReplicationMessage();
            }
        }

        */


        /// <summary>
        /// Retreive messages from database
        /// </summary>
        /// <returns></returns>
        public DataTable GetShareState()
        {
            DataTable dt = new DataTable();

            try
            {
                // Create command
                // Command must use two part names for tables
                // SELECT <field> FROM dbo.Table rather than 
                // SELECT <field> FROM Table
                // Query also can not use *, fields must be designated
                SqlCommand cmd = new SqlCommand("SELECT artifactID, artifactHWND, artifactFullShare FROM dbo.SharedArtifacts WHERE artifactGroup = @artifactGroup", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@artifactGroup", hostnameToMonitor);

                // Clear any existing notifications
                //cmd.Notification = null;

                // Create the dependency for this command
               // SqlDependency dependency = new SqlDependency(cmd);

                // Add the event handler
                //dependency.OnChange += new OnChangeEventHandler(OnPermissionChange);

                // Open the connection if necessary
                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                // Get the messages
                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return dt;
        }

        /*
        /// <summary>
        /// Handler for the SqlDependency OnChange event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void OnPermissionChange(object sender, SqlNotificationEventArgs e)
        {
            SqlDependency dependency = sender as SqlDependency;

            // Notices are only a one shot deal
            // so remove the existing one so a new 
            // one can be added
            dependency.OnChange -= OnPermissionChange;

            // Fire the event
            if (OnNewPermissionMessage != null)
            {
                OnNewPermissionMessage();
            }
        }
        */


        public int GetCurrentPermission(string host, int HWND)
        {

            DataTable dt = new DataTable();

            try
            {
                SqlCommand cmd = new SqlCommand("SELECT artifactFullShare FROM dbo.SharedArtifacts WHERE (artifactGroup = @artifactGroup) AND (artifactHWND = @artifactHWND)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@artifactGroup", host);
                cmd.Parameters.AddWithValue("@artifactHWND", HWND);

                cmd.Notification = null;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                // Get the messages
                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));

            }
            catch (Exception)
            {
                return 0;
            }

            if (dt.Rows.Count != 1)
                return 0;

            if (((bool)dt.Rows[0]["artifactFullShare"]) == true)
                return 2;

            if (((bool)dt.Rows[0]["artifactFullShare"]) == false)
                return 1;

            return 0;
            

        }


        public void InitialReplicationTableClean(string host)
        {
            SqlConnection m_sqlConn = new SqlConnection(m_ConnectionString);
            SqlCommand cmd = new SqlCommand("DELETE FROM dbo.Replications WHERE (replicationSourceHost = @replicationSourceHost)", m_sqlConn);
            cmd.CommandType = CommandType.Text;
            cmd.Parameters.AddWithValue("@replicationSourceHost", host);

            if (m_sqlConn.State == ConnectionState.Closed)
                m_sqlConn.Open();

          

            try
            {
                cmd.ExecuteNonQuery();
            }
            finally
            {
                m_sqlConn.Close();
            }
        }

        public static int GetReplicationIsSharedScreen(long replicationID)
        {
            DataTable dt = new DataTable();

            try
            {
                SqlConnection m_sqlConn = new SqlConnection(m_ConnectionString);
                SqlCommand cmd = new SqlCommand("SELECT replicationIsSharedScreen FROM dbo.Replications WHERE (replicationID = @replicationID)", m_sqlConn);
                cmd.CommandType = CommandType.Text;
                cmd.Parameters.AddWithValue("@replicationID", replicationID);
                
                cmd.Notification = null;

                if (m_sqlConn.State == ConnectionState.Closed)
                    m_sqlConn.Open();

                // Get the messages
                dt.Load(cmd.ExecuteReader(CommandBehavior.CloseConnection));

            }
            catch (Exception)
            {
                return -1;
            }

            if (dt.Rows.Count != 1)
                return -1;

            if (((bool)dt.Rows[0]["replicationIsSharedScreen"]) == true)
                return 1;

            return 0;
        }

        public static void UpdateReplication(long replicationID, int clientHWND)
        {
            SqlConnection m_sqlConn = new SqlConnection(m_ConnectionString);
            SqlCommand cmd = new SqlCommand("UPDATE dbo.Replications SET replicationClientHWND = @replicationClientHWND WHERE (replicationID = @replicationID)", m_sqlConn);
            cmd.CommandType = CommandType.Text;
            cmd.Parameters.AddWithValue("@replicationClientHWND", clientHWND);
            cmd.Parameters.AddWithValue("@replicationID", replicationID);

            if (m_sqlConn.State == ConnectionState.Closed)
                m_sqlConn.Open();



            try
            {
                cmd.ExecuteNonQuery();
            }
            finally
            {
                m_sqlConn.Close();
            }
        }

        public void RemoveReplication(long replicationID)
        {
            SqlConnection m_sqlConn = new SqlConnection(m_ConnectionString);
            SqlCommand cmd = new SqlCommand("DELETE FROM dbo.Replications WHERE (replicationID = @replicationID)", m_sqlConn);
            cmd.CommandType = CommandType.Text;
            cmd.Parameters.AddWithValue("@replicationID", replicationID);

            if (m_sqlConn.State == ConnectionState.Closed)
                m_sqlConn.Open();



            try
            {
                cmd.ExecuteNonQuery();
            }
            finally
            {
                m_sqlConn.Close();
            }
        }
    }
}
