using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace PARTIES
{
    public class NetworkMessages
    {
        public enum MessageType
        {
            // TO SERVER FROM CLIENT:
            KeyBoardBuffer,           
            MouseDown,              
            MouseDblClick,
            ClientHWND,
            ClipboardPaste,
            ClipboardCut,
            ClipboardCopy,
            ClientClosing,

            // TO SERVER FROM DISPATCH AND
            // TO CLIENT FROM SERVER
            ChangePermissions,
            CloseReplication,
          
            // TO CLIENT:
            TitleBarText,           
            ScreenShot,
            WindowWidthHeight,
            ServerClosing,
            Permissions,
            NewMenu,
            Icon,

            // TO DISPATCH SERVER FROM DISPATCH SERVER
            StartClient,

            // TO DISPATCH SERVER FROM REPLICATION SERVER
            CloseReplicationServer,

            // TO SERVER AND CLIENT FROM EACH OTHER
            MousePosition
        };

        public enum TelepointerMessages
        {
            ServerRequest,
            ClientRequest,
            EndClientRequest,
            EndingClientTelepointer,
            //EndingServerTelepointer,
            MousePosition,
            MouseOut
        }

        public enum MouseButton
        {
            Left,
            Middle,
            Right
        };

        public delegate void exceptionCallback();


        public static void safeWrite(NetworkStream stream, byte[] buffer, int offset, int size, exceptionCallback ec)
        {
            try
            {
                stream.Write(buffer,offset,size);
            }
            catch (Exception)
            {
                ec();
            }
        }

        public static void noOp()
        {

        }
    

    }
}
