using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Collections;

namespace PARTIES
{
    // This class is a form that actually looks like a pointer
    // It is controlled by the Telepointer PtoP class
    public partial class Telepointer : Form
    {
        public Telepointer(KnownColor color, float brightness, Point location)
        {
            InitializeComponent();

            this.Location = location;

            Bitmap pointer = (Bitmap)pictureBox1.Image;
            Bitmap new_pointer = CommonThreadCode.matrixColorFilter(pointer, Color.FromKnownColor(color), brightness);
            this.pictureBox1.Image = new_pointer; 
        }

        public delegate void moveToDelegate(Point new_location);
        public void moveTo(Point new_location)
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                this.BeginInvoke(new moveToDelegate(moveTo),
                                                  new object[] { new_location });

                return;
            }
            Location = new_location;
        }

        public delegate void showMeDelegate();
        public void showMe()
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                this.BeginInvoke(new showMeDelegate(showMe), null);

                return;
            }
            this.Show();
        }

        public delegate void hideMeDelegate();
        public void hideMe()
        {
            if (this.InvokeRequired)  //i.e. if we are trying to set the text and we aren't the main thread
            {
                this.BeginInvoke(new hideMeDelegate(hideMe), null);

                return;
            }
            this.Hide();
        }

    }
}