using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace PARTIES
{
    public partial class TelepointersSampleApp : Form
    {
        TelepointerPtoP telepointer_server;

        public TelepointersSampleApp()
        {
            InitializeComponent();
            telepointer_server = new TelepointerPtoP(20);
            telepointer_server.Show();
            
            foreach (string colorname in Enum.GetNames(typeof(KnownColor)))
                comboBox1.Items.Add(colorname);
        }

        private void startLocalClientButton_Click(object sender, EventArgs e)
        {
            IPHostEntry remote_host = Dns.GetHostEntry(hostNametext.Text);
            IPAddress remote_ip = IPAddress.Loopback;
            for (int i = 0; i < remote_host.AddressList.Length; i++)
            {
                if (remote_host.AddressList[i].AddressFamily == AddressFamily.InterNetwork)
                {
                    remote_ip = remote_host.AddressList[i];
                    break;
                }
            }

            
            KnownColor newColor = (KnownColor)(comboBox1.SelectedIndex + 1);
            

            telepointer_server.addLocalClient((IntPtr)Convert.ToInt32(localHWNDtextbox.Text),
                                              (IntPtr)Convert.ToInt32(remoteHWNDtextbox.Text),
                                              remote_ip, newColor, (float)Convert.ToDouble(brightnessText.Text));
        }

        private void startTelepointersPtoP_Click(object sender, EventArgs e)
        {
            telepointer_server.startTelepointerServer();
        }

        private void startRemoteClientButton_Click(object sender, EventArgs e)
        {
            IPHostEntry remote_host = Dns.GetHostEntry(hostNametext.Text);
            IPAddress remote_ip = IPAddress.Loopback;
            for (int i = 0; i < remote_host.AddressList.Length; i++)
            {
                if (remote_host.AddressList[i].AddressFamily == AddressFamily.InterNetwork)
                {
                    remote_ip = remote_host.AddressList[i];
                    break;
                }
            }

            
            KnownColor newColor = (KnownColor)(comboBox1.SelectedIndex+1);

            telepointer_server.addRemoteClient((IntPtr)Convert.ToInt32(remoteHWNDtextbox.Text),
                                              (IntPtr)Convert.ToInt32(localHWNDtextbox.Text),
                                              remote_ip, newColor, (float)Convert.ToDouble(brightnessText.Text));
        }

        private void stopLocalTelepointersButton_Click(object sender, EventArgs e)
        {
            IPHostEntry remote_host = Dns.GetHostEntry(hostNametext.Text);
            IPAddress remote_ip = IPAddress.Loopback;
            for (int i = 0; i < remote_host.AddressList.Length; i++)
            {
                if (remote_host.AddressList[i].AddressFamily == AddressFamily.InterNetwork)
                {
                    remote_ip = remote_host.AddressList[i];
                    break;
                }
            }

            telepointer_server.stopLocalClient((IntPtr)Convert.ToInt32(localHWNDtextbox.Text),
                                              (IntPtr)Convert.ToInt32(remoteHWNDtextbox.Text),
                                              remote_ip);
        }

        private void stopRemoteClientButton_Click(object sender, EventArgs e)
        {
            IPHostEntry remote_host = Dns.GetHostEntry(hostNametext.Text);
            IPAddress remote_ip = IPAddress.Loopback;
            for (int i = 0; i < remote_host.AddressList.Length; i++)
            {
                if (remote_host.AddressList[i].AddressFamily == AddressFamily.InterNetwork)
                {
                    remote_ip = remote_host.AddressList[i];
                    break;
                }
            }

            telepointer_server.stopRemoteClient((IntPtr)Convert.ToInt32(remoteHWNDtextbox.Text),
                                              (IntPtr)Convert.ToInt32(localHWNDtextbox.Text),
                                              remote_ip);
        }

        private void stopAllLocalButton_Click(object sender, EventArgs e)
        {
            telepointer_server.stopServer((IntPtr)Convert.ToInt32(localHWNDtextbox.Text));
        }
    }
}