using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;

namespace PARTIES
{
    public class Win32Api
    {

        
                                    

        public delegate bool EnumWindowsCallBack(int hwnd, IntPtr param);
        public delegate bool EnumChildCallBack(int hwnd, IntPtr param);

        public struct Rect
        {
            public Int32 left;
            public Int32 top;
            public Int32 right;
            public Int32 bottom;

            public int Width
            {
                get
                {
                    return right - left;
                }

            }

            public int Height
            {
                get
                {
                    return bottom - top;
                }
            }
        }

        public struct WindowInfo
        {
            public UInt32 cbSize;
            public Rect rcWindow;
            public Rect rcClient;
            public UInt32 dwStyle;
            public UInt32 dwExStyle;
            public UInt32 dwWindowStatus;
            public UInt32 cxWindowsBorders;
            public UInt32 cyWindowsBorders;
            public UInt16 atomWindowType;
            public UInt16 wCreatorVersion;
        }

        

        public struct PointWin32
        {
            public int x;
            public int y;
        }

        public struct CursorInfo
        {
            public UInt32 cbSize;
            public UInt32 flags;
            public UInt32 hCursor;
            public PointWin32 ptScreenPos;

        }

        [DllImport("user32.dll")]
        public static extern int EnumWindows(EnumWindowsCallBack cb, IntPtr param);

        [DllImport("user32.dll")]
        public static extern bool GetWindowRect(IntPtr hwnd, ref Rect rectangle);

        [DllImport("user32.dll")]
        public static extern bool GetClientRect(IntPtr hwnd, ref Rect rectangle);

        [DllImport("user32.dll")]
        public static extern bool IsWindowVisible(IntPtr hwnd);

        [DllImport("user32.dll")]
        public static extern IntPtr GetParent(IntPtr hwnd);

        [DllImport("user32.dll")]
        public static extern int GetWindowText(IntPtr hwnd, StringBuilder lpString, int nMaxCount);

        public const uint GA_PARENT = 1;
        public const uint     GA_ROOT  =       2;
        public const uint GA_ROOTOWNER = 3;
        
        [DllImport("user32.dll")]
        public static extern IntPtr GetAncestor(IntPtr hwnd, uint gaFlags);


         public const uint GW_HWNDNEXT     =    2;
         public const uint GW_HWNDPREV    =     3;

        public IntPtr GetNextWindow(IntPtr hwnd, uint wCmd)
        {
            return GetWindow(hwnd, wCmd);
        }

        [DllImport("user32.dll")]
        public static extern IntPtr GetWindow(IntPtr hwnd, uint wCmd);
        
        [DllImport("user32.dll")]
        public static extern IntPtr GetTopWindow(IntPtr hwnd);


        [DllImport("user32.dll")]
        public static extern IntPtr GetDesktopWindow();

        public const uint SWP_NOSIZE = 0x0001;
        public const uint SWP_NOMOVE = 0x0002;
        public const uint SWP_NOZORDER = 0x0004;
        public const uint SWP_NOREDRAW = 0x0008;
        public const uint SWP_NOACTIVATE = 0x0010;
        public const uint SWP_FRAMECHANGED = 0x0020;  /* The frame changed: send WM_NCCALCSIZE */
        public const uint SWP_SHOWWINDOW = 0x0040;
        public const uint SWP_HIDEWINDOW = 0x0080;
        public const uint SWP_NOCOPYBITS = 0x0100;
        public const uint SWP_NOOWNERZORDER = 0x0200;  /* Don't do owner Z ordering */
        public const uint SWP_NOSENDCHANGING = 0x0400;  /* Don't send WM_WINDOWPOSCHANGING */
        public const uint SWP_DEFERERASE  =    0x2000;
        public const uint SWP_ASYNCWINDOWPOS = 0x4000;

        public const int HWND_TOP = 0;
        public const int HWND_BOTTOM   = 1;
        public const int HWND_TOPMOST  =  -1;
        public const int HWND_NOTOPMOST = -2;

        [DllImport("user32.dll")]
        public static extern bool SetWindowPos(int hwnd, int hWndInsertAfter, int x,
                    int y, int cx, int cz, uint flags);

        [DllImport("user32.dll")]
        public static extern bool SetForegroundWindow(int hwnd);

        public const uint PW_CLIENTONLY = 0x00000001;
        [DllImport("user32.dll")]
        public static extern bool PrintWindow(IntPtr hwnd, IntPtr hdcBlt, uint nFlags);


        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr FindWindow(StringBuilder lpClassName, StringBuilder lpWindowName);
        public const uint WM_PAINT = 0x000F;
        public const uint WM_ACTIVATE = 0x0006;
        public const uint WM_ACTIVATEAPP = 0x001C;
        public const uint WM_INPUT                        = 0x00FF;
        public const uint WM_KEYFIRST                     = 0x0100;
        public const uint WM_KEYDOWN                      = 0x0100;
        public const uint WM_KEYUP                        = 0x0101;
        public const uint WM_CHAR                         = 0x0102;
        public const uint WM_DEADCHAR                     = 0x0103;
        public const uint WM_SYSKEYDOWN                   = 0x0104;
        public const uint WM_SYSKEYUP                     = 0x0105;
        public const uint WM_SYSCHAR                      = 0x0106;
        public const uint WM_SYSDEADCHAR                  = 0x0107;
        public const uint WM_UNICHAR                      = 0x0109;
        public const uint WM_KEYLAST                      = 0x0109;
        public const uint UNICODE_NOCHAR                  = 0xFFFF;
        //public const uint WM_KEYLAST                      = 0x0108;
        public const uint WM_IME_STARTCOMPOSITION         = 0x010D;
        public const uint WM_IME_ENDCOMPOSITION           = 0x010E;
        public const uint WM_IME_COMPOSITION              = 0x010F;
        public const uint WM_IME_KEYLAST = 0x010F;


        public const uint WM_MOUSEFIRST    =               0x0200;
        public const uint WM_MOUSEMOVE      =              0x0200;
        public const uint WM_LBUTTONDOWN     =             0x0201;
        public const uint WM_LBUTTONUP        =            0x0202;
        public const uint WM_LBUTTONDBLCLK     =           0x0203;
        public const uint WM_RBUTTONDOWN        =          0x0204;
        public const uint WM_RBUTTONUP           =         0x0205;
        public const uint WM_RBUTTONDBLCLK        =        0x0206;
        public const uint WM_MBUTTONDOWN           =       0x0207;
        public const uint WM_MBUTTONUP              =      0x0208;
        public const uint WM_MBUTTONDBLCLK           =     0x0209;

                
        public const uint WM_MOUSEHOVER      =             0x02A1;
        public const uint WM_MOUSELEAVE       =            0x02A3;
        public const uint WM_NCMOUSEHOVER      =           0x02A0;
        public const uint WM_NCMOUSELEAVE       =          0x02A2;

        public const uint WM_CAPTURECHANGED = 0x0215;

        public const uint WM_SETREDRAW            = 0x000B;

        public const uint WM_NCHITTEST = 0x0084;

        public const uint WA_INACTIVE = 0;
        public const uint     WA_ACTIVE      = 1;
        public const uint     WA_CLICKACTIVE = 2;

        public const uint MK_LBUTTON     =     0x0001;
        public const uint MK_RBUTTON     =     0x0002;
        public const uint MK_SHIFT       =     0x0004;
        public const uint MK_CONTROL     =     0x0008;
        public const uint MK_MBUTTON     =     0x0010;

        public const uint MK_XBUTTON1     =    0x0020;
        public const uint MK_XBUTTON2 = 0x0040;


        public const uint HTNOWHERE   =        0;
        public const uint HTCLIENT     =       1;
        public const uint HTCAPTION     =      2;
        public const uint HTSYSMENU     =      3;
        public const uint HTGROWBOX     =      4;
        public const uint HTSIZE        =      HTGROWBOX;
        public const uint HTMENU        =      5;
        public const uint HTHSCROLL     =      6;
        public const uint HTVSCROLL     =      7;
        public const uint HTMINBUTTON   =      8;
        public const uint HTMAXBUTTON   =      9;
        public const uint HTLEFT        =      10;
        public const uint HTRIGHT       =      11;
        public const uint HTTOP         =      12;
        public const uint HTTOPLEFT     =      13;
        public const uint HTTOPRIGHT    =      14;
        public const uint HTBOTTOM      =      15;
        public const uint HTBOTTOMLEFT   =     16;
        public const uint HTBOTTOMRIGHT  =     17;
        public const uint HTBORDER     =       18;
        public const uint HTREDUCE     =       HTMINBUTTON;
        public const uint HTZOOM       =       HTMAXBUTTON;
        public const uint HTSIZEFIRST    =     HTLEFT;
        public const uint HTSIZELAST     =     HTBOTTOMRIGHT;

        public const uint HTOBJECT      =      19;
        public const uint HTCLOSE       =      20;
        public const uint HTHELP        =      21;



        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr SendMessage(
            IntPtr hWnd, uint nMsg, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr PostMessage(
            IntPtr hWnd, uint nMsg, uint wParam, uint lParam);

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr SendMessage(
            IntPtr hWnd, uint nMsg, IntPtr wParam, StringBuilder lParam);

        [DllImport("user32.dll")]
        public static extern bool EnumChildWindows(
            IntPtr hWnd, EnumChildCallBack cb, IntPtr lParam);


        public const uint CWP_ALL             = 0x0000;
        public const uint CWP_SKIPINVISIBLE   = 0x0001;
        public const uint CWP_SKIPDISABLED    = 0x0002;
        public const uint CWP_SKIPTRANSPARENT = 0x0004;


        [DllImport("user32.dll")]
        public static extern IntPtr WindowFromPoint(
            PointWin32 pt);


        [DllImport("user32.dll")]
        public static extern IntPtr ChildWindowFromPointEx(
            IntPtr hWndParent,  PointWin32 pt, uint flags);

        [DllImport("user32.dll")]
        public static extern bool InvalidateRect(
            IntPtr hWnd, IntPtr lpRect, bool erase);

        [DllImport("user32.dll")]
        public static extern bool UpdateWindow(
            IntPtr hWnd);

        [DllImport("user32.dll")]
        public static extern IntPtr SetActiveWindow(
            IntPtr hwnd);

        
        public const long WS_OVERLAPPED       = 0x00000000L;
        public const long WS_POPUP            = 0x80000000L;
        public const long WS_CHILD            = 0x40000000L;
        public const long WS_MINIMIZE         = 0x20000000L;
        public const long WS_VISIBLE          = 0x10000000L;
        public const long WS_DISABLED         = 0x08000000L;
        public const long WS_CLIPSIBLINGS     = 0x04000000L;
        public const long WS_CLIPCHILDREN     = 0x02000000L;
        public const long WS_MAXIMIZE         = 0x01000000L;
        public const long WS_CAPTION          = 0x00C00000L;     /* WS_BORDER | WS_DLGFRAME  */
        public const long WS_BORDER           = 0x00800000L;
        public const long WS_DLGFRAME         = 0x00400000L;
        public const long WS_VSCROLL          = 0x00200000L;
        public const long WS_HSCROLL          = 0x00100000L;
        public const long WS_SYSMENU          = 0x00080000L;
        public const long WS_THICKFRAME       = 0x00040000L;
        public const long WS_GROUP            = 0x00020000L;
        public const long WS_TABSTOP          = 0x00010000L;

        public const long WS_MINIMIZEBOX      = 0x00020000L;
        public const long WS_MAXIMIZEBOX      = 0x00010000L;



        public const long WS_EX_DLGMODALFRAME     = 0x00000001L;
        public const long WS_EX_NOPARENTNOTIFY    = 0x00000004L;
        public const long WS_EX_TOPMOST           = 0x00000008L;
        public const long WS_EX_ACCEPTFILES       = 0x00000010L;
        public const long WS_EX_TRANSPARENT       = 0x00000020L;

        public const long WS_EX_MDICHILD          = 0x00000040L;
        public const long WS_EX_TOOLWINDOW        = 0x00000080L;
        public const long WS_EX_WINDOWEDGE        = 0x00000100L;
        public const long WS_EX_CLIENTEDGE        = 0x00000200L;
        public const long WS_EX_CONTEXTHELP       = 0x00000400L;



        public const long WS_EX_RIGHT             = 0x00001000L;
        public const long WS_EX_LEFT              = 0x00000000L;
        public const long WS_EX_RTLREADING        = 0x00002000L;
        public const long WS_EX_LTRREADING        = 0x00000000L;
        public const long WS_EX_LEFTSCROLLBAR     = 0x00004000L;
        public const long WS_EX_RIGHTSCROLLBAR    = 0x00000000L;

        public const long WS_EX_CONTROLPARENT     = 0x00010000L;
        public const long WS_EX_STATICEDGE        = 0x00020000L;
        public const long WS_EX_APPWINDOW         = 0x00040000L;


        public const long WS_EX_OVERLAPPEDWINDOW  = (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE);
        public const long WS_EX_PALETTEWINDOW     = (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST);


        public const uint WS_EX_LAYERED           = 0x00080000;


        public const long WS_EX_NOINHERITLAYOUT   = 0x00100000L; // Disable inheritence of mirroring by children
        public const long WS_EX_LAYOUTRTL         = 0x00400000L; // Right to left mirroring

        public const long WS_EX_COMPOSITED        = 0x02000000L;

        public const long WS_EX_NOACTIVATE = 0x08000000L;

        [DllImport("user32.dll")]
        public static extern bool GetWindowInfo(
            IntPtr hwnd, out WindowInfo pwi);

        [DllImport("user32.dll")]
        public static extern bool GetCursorInfo(
            out CursorInfo pci);


        [DllImport("user32.dll")]
        public static extern bool IsWindow(
            IntPtr hwnd);

        [DllImport("user32.dll")]
        public static extern int ShowCursor(
            bool bShow);

        // CopyCursor = CopyIcon

        [DllImport("user32.dll")]
        public static extern IntPtr CopyIcon(
            IntPtr pcur);

        [DllImport("user32.dll")]
        public static extern IntPtr SetCursor(
            IntPtr hCursor);

        public const uint NORMAL_PRIORITY_CLASS             = 0x00000020;
        public const uint IDLE_PRIORITY_CLASS               = 0x00000040;
        public const uint HIGH_PRIORITY_CLASS               = 0x00000080;
        public const uint REALTIME_PRIORITY_CLASS           = 0x00000100;
        public const uint BELOW_NORMAL_PRIORITY_CLASS       = 0x00004000;
        public const uint ABOVE_NORMAL_PRIORITY_CLASS = 0x00008000;

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool SetPriorityClass(
            uint hProcess, uint dwPriorityClass);

        [DllImport("user32.dll")]
        public static extern uint GetWindowThreadProcessId(
            IntPtr hWnd, out uint lpdwProcessId);

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern int GetLastError();

        [DllImport("user32.dll")]
        public static extern int GetClassName(
            IntPtr hwnd, StringBuilder lpString, int nMaxCount);

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        public const uint DCX_WINDOW           = 0x00000001;
        public const uint DCX_CACHE            = 0x00000002;
        public const uint DCX_NORESETATTRS     = 0x00000004;
        public const uint DCX_CLIPCHILDREN     = 0x00000008;
        public const uint DCX_CLIPSIBLINGS     = 0x00000010;
        public const uint DCX_PARENTCLIP       = 0x00000020;
        public const uint DCX_EXCLUDERGN       = 0x00000040;
        public const uint DCX_INTERSECTRGN     = 0x00000080;
        public const uint DCX_EXCLUDEUPDATE    = 0x00000100;
        public const uint DCX_INTERSECTUPDATE  = 0x00000200;
        public const uint DCX_LOCKWINDOWUPDATE = 0x00000400;

        public const uint DCX_VALIDATE         = 0x00200000;

        [DllImport("user32.dll")]
        public static extern IntPtr GetDCEx(
            IntPtr hWnd, IntPtr hrgnClip, uint flags);

        [DllImport("user32.dll")]
        public static extern int ReleaseDC(
            IntPtr hWnd, IntPtr hDC);

        public const uint SRCCOPY = 0x00CC0020;

        [DllImport("gdi32.dll")]
        public static extern bool BitBlt(
            IntPtr hdc, int nXDest, int nYDest, int nWidth, 
            int nHeight, IntPtr hdcSrc, int nXSrc, int nYSrc, uint dwRop);

        public const int GWL_HWNDPARENT = (-8);
        public const int GWL_EXSTYLE = (-20);
        public const int GWL_STYLE = (-16);
        public const int GCL_HICON = (-14);
        public const int GCL_HICONSM = (-34);
        public const int WM_QUERYDRAGICON = 0x37;
        public const int WM_GETICON = 0x7F;
        public const int WM_SETICON = 0x80;
        public const int ICON_SMALL = 0;
        public const int ICON_BIG = 1;
        public const int SMTO_ABORTIFHUNG = 0x2;
        public const int TRUE = 1;
        public const int FALSE = 0;

        [DllImport("user32.dll")]
        public static extern int SendMessageTimeout(IntPtr hWnd, int uMsg, int wParam, int lParam, int fuFlags, int uTimeout, out int lpdwResult);

        [DllImport("user32.dll")]
        public static extern int GetClassLong(IntPtr hWnd, int index);

        /*
             VK_LBUTTON 	01 	Left mouse button
            VK_RBUTTON 	02 	Right mouse button
            VK_CANCEL 	03 	Control-break processing
            VK_MBUTTON 	04 	Middle mouse button (three-button mouse)
            VK_BACK 	08 	BACKSPACE key
            VK_TAB 	    09 	TAB key
            VK_CLEAR 	0C 	CLEAR key
            VK_RETURN 	0D 	ENTER key
            VK_SHIFT 	10 	SHIFT key
            VK_CONTROL 	11 	CTRL key
            VK_MENU 	12 	ALT key
            VK_PAUSE 	13 	PAUSE key
            VK_CAPITAL 	14 	CAPS LOCK key
            VK_ESCAPE 	1B 	ESC key
            VK_SPACE 	20 	SPACEBAR
            VK_PRIOR 	21 	PAGE UP key
            VK_NEXT 	22 	PAGE DOWN key
            VK_END 	23 	END key
            VK_HOME 	24 	HOME key
            VK_LEFT 	25 	LEFT ARROW key
            VK_UP 	26 	UP ARROW key
            VK_RIGHT 	27 	RIGHT ARROW key
            VK_DOWN 	28 	DOWN ARROW key
            VK_SELECT 	29 	SELECT key
            VK_PRINT 	2A 	PRINT key
            VK_EXECUTE 	2B 	EXECUTE key
            VK_SNAPSHOT 	2C 	PRINT SCREEN key
            VK_INSERT 	2D 	INS key
            VK_DELETE 	2E 	DEL key
            VK_HELP 	2F 	HELP key
	            30 	0 key
	            31 	1 key
	            32 	2 key
	            33 	3 key
	            34 	4 key
	            35 	5 key
	            36 	6 key
	            37 	7 key
	            38 	8 key
	            39 	9 key
	            41 	A key
	            42 	B key
	            43 	C key
	            44 	D key
	            45 	E key
	            46 	F key
	            47 	G key
	            48 	H key
	            49 	I key
	            4A 	J key
	            4B 	K key
	            4C 	L key
	            4D 	M key
	            4E 	N key
	            4F 	O key
	            50 	P key
	            51 	Q key
	            52 	R key
	            53 	S key
	            54 	T key
	            55 	U key
	            56 	V key
	            57 	W key
	            58 	X key
	            59 	Y key
	            5A 	Z key
            VK_NUMPAD0 	60 	Numeric keypad 0 key
            VK_NUMPAD1 	61 	Numeric keypad 1 key
            VK_NUMPAD2 	62 	Numeric keypad 2 key
            VK_NUMPAD3 	63 	Numeric keypad 3 key
            VK_NUMPAD4 	64 	Numeric keypad 4 key
            VK_NUMPAD5 	65 	Numeric keypad 5 key
            VK_NUMPAD6 	66 	Numeric keypad 6 key
            VK_NUMPAD7 	67 	Numeric keypad 7 key
            VK_NUMPAD8 	68 	Numeric keypad 8 key
            VK_NUMPAD9 	69 	Numeric keypad 9 key
            VK_SEPARATOR 	6C 	Separator key
            VK_SUBTRACT 	6D 	Subtract key
            VK_DECIMAL 	6E 	Decimal key
            VK_DIVIDE 	6F 	Divide key
            VK_F1 	70 	F1 key
            VK_F2 	71 	F2 key
            VK_F3 	72 	F3 key
            VK_F4 	73 	F4 key
            VK_F5 	74 	F5 key
            VK_F6 	75 	F6 key
            VK_F7 	76 	F7 key
            VK_F8 	77 	F8 key
            VK_F9 	78 	F9 key
            VK_F10 	79 	F10 key
            VK_F11 	7A 	F11 key
            VK_F12 	7B 	F12 key
            VK_F13 	7C 	F13 key
            VK_F14 	7D 	F14 key
            VK_F15 	7E 	F15 key
            VK_F16 	7F 	F16 key
            VK_F17 	80H 	F17 key
            VK_F18 	81H 	F18 key
            VK_F19 	82H 	F19 key
            VK_F20 	83H 	F20 key
            VK_F21 	84H 	F21 key
            VK_F22 	85H 	F22 key
            VK_F23 	86H 	F23 key
            VK_F24 	87H 	F24 key
            VK_NUMLOCK 	90 	NUM LOCK key
            VK_SCROLL 	91 	SCROLL LOCK key
            VK_LSHIFT 	A0 	Left SHIFT key
            VK_RSHIFT 	A1 	Right SHIFT key
            VK_LCONTROL 	A2 	Left CONTROL key
            VK_RCONTROL 	A3 	Right CONTROL key
            VK_LMENU 	A4 	Left MENU key
            VK_RMENU 	A5 	Right MENU key
            VK_PLAY 	FA 	Play key
            VK_ZOOM 	FB 	Zoom key
         */
    
    
    
    
    }
}
